
% Domain: driverlog
#base.
% 
% 
% EFFECTS: ADD  >>>>>
adds( unloadtruck( Obj,Truck,Loc ),at( Obj,Loc ) ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
adds( boardtruck( Driver,Truck,Loc ),driving( Driver,Truck ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
adds( loadtruck( Obj,Truck,Loc ),in( Obj,Truck ) ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
adds( disembarktruck( Driver,Truck,Loc ),at( Driver,Loc ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
adds( disembarktruck( Driver,Truck,Loc ),empty( Truck ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
adds( walk( Driver,Locfrom,Locto ),at( Driver,Locto ) ) :- holds( path( Locfrom,Locto ) ), typedobject( driver( Driver ) ).
adds( drivetruck( Truck,Locfrom,Locto,Driver ),at( Truck,Locto ) ) :- holds( link( Locfrom,Locto ) ), typedobject( truck( Truck ) ), typedobject( driver( Driver ) ).
% <<<<<  EFFECTS: ADD
% 

% 
% 
% EFFECTS: DEL  >>>>>
deletes( unloadtruck( Obj,Truck,Loc ),in( Obj,Truck ) ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
deletes( boardtruck( Driver,Truck,Loc ),at( Driver,Loc ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
deletes( boardtruck( Driver,Truck,Loc ),empty( Truck ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
deletes( loadtruck( Obj,Truck,Loc ),at( Obj,Loc ) ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
deletes( disembarktruck( Driver,Truck,Loc ),driving( Driver,Truck ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
deletes( walk( Driver,Locfrom,Locto ),at( Driver,Locfrom ) ) :- holds( path( Locfrom,Locto ) ), typedobject( driver( Driver ) ).
deletes( drivetruck( Truck,Locfrom,Locto,Driver ),at( Truck,Locfrom ) ) :- holds( link( Locfrom,Locto ) ), typedobject( truck( Truck ) ), typedobject( driver( Driver ) ).
% <<<<<  EFFECTS: DEL
% 

% 
% 
% TYPES  >>>>>
typedobject( locatable( X ) ) :- typedobject( truck( X ) ).
typedobject( locatable( X ) ) :- typedobject( driver( X ) ).
typedobject( locatable( X ) ) :- typedobject( obj( X ) ).
object( X ) :- typedobject( locatable( X ) ).
object( X ) :- typedobject( location( X ) ).
% <<<<<  TYPES
% 

% 
% 
% REIFIED ENCODING OF DOMAIN ACTIONS  >>>>>
action( unloadtruck( Obj,Truck,Loc ) ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
action( boardtruck( Driver,Truck,Loc ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
action( loadtruck( Obj,Truck,Loc ) ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
action( disembarktruck( Driver,Truck,Loc ) ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
action( walk( Driver,Locfrom,Locto ) ) :- holds( path( Locfrom,Locto ) ), typedobject( driver( Driver ) ).
action( drivetruck( Truck,Locfrom,Locto,Driver ) ) :- holds( link( Locfrom,Locto ) ), typedobject( truck( Truck ) ), typedobject( driver( Driver ) ).
% <<<<<  REIFIED ENCODING OF DOMAIN ACTIONS
% 

% 
% 
% REIFIED ENCODING OF PRECONDITIONS  >>>>>
demands( unloadtruck( Obj,Truck,Loc ),at( Truck,Loc ),true ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( unloadtruck( Obj,Truck,Loc ),in( Obj,Truck ),true ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( boardtruck( Driver,Truck,Loc ),at( Truck,Loc ),true ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( boardtruck( Driver,Truck,Loc ),at( Driver,Loc ),true ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( boardtruck( Driver,Truck,Loc ),empty( Truck ),true ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( loadtruck( Obj,Truck,Loc ),at( Truck,Loc ),true ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( loadtruck( Obj,Truck,Loc ),at( Obj,Loc ),true ) :- typedobject( obj( Obj ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( disembarktruck( Driver,Truck,Loc ),at( Truck,Loc ),true ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( disembarktruck( Driver,Truck,Loc ),driving( Driver,Truck ),true ) :- typedobject( driver( Driver ) ), typedobject( truck( Truck ) ), typedobject( location( Loc ) ).
demands( walk( Driver,Locfrom,Locto ),at( Driver,Locfrom ),true ) :- holds( path( Locfrom,Locto ) ), typedobject( driver( Driver ) ).
demands( drivetruck( Truck,Locfrom,Locto,Driver ),at( Truck,Locfrom ),true ) :- holds( link( Locfrom,Locto ) ), typedobject( truck( Truck ) ), typedobject( driver( Driver ) ).
demands( drivetruck( Truck,Locfrom,Locto,Driver ),driving( Driver,Truck ),true ) :- holds( link( Locfrom,Locto ) ), typedobject( truck( Truck ) ), typedobject( driver( Driver ) ).
% <<<<<  REIFIED ENCODING OF PRECONDITIONS
% 

